module Main where

import Maybe (isJust)
import AFRP
import AFrob
import AFrobPioneer
import AFVision

infixr 1 <<<

(<<<) = flip (>>>)

rotate :: ST PioneerInput PioneerOutput
rotate = proc inp -> do
    mpos <- trackAndHold (0,0) -< fvgiMousePos inp
    let lbd = isJust (fvgiMouseLB inp)
    rbe <- edgeJust -< fvgiMouseRB inp
    rbps <- stepAccum [] -< fmap (:) rbe
    s <- (stepAccum [] <<< arr (fmap (:)) <<< edgeJust) -< tciKey inp
    returnA -< coMake (ddSetVelDiff 0.1 (-0.1)
		       `coCompose` fvgoOverlaySimpleGraphic (square mpos lbd s)
		       `coCompose` fvgoOverlaySimpleGraphic (drawMarkers rbps))
    where
	square (x,y) lbd s = (SGRectangle (x-50,y-50) (x+50,y+50) False Red)
			     `SGOver` (if lbd then
					   SGText (x,y) s 12 Green
					   `SGOver` SGPolygon [(x, y-50),
						               (x+50, y),
						      	       (x, y+50),
						               (x-50, y)]
						              Purple
				       else
					   SGEmpty)

	drawMarker (x,y) = SGEllipse (x-20, y-10) (x+20,y+10) True Orange

	drawMarkers [] = SGEmpty
        drawMarkers (p:ps) = drawMarker p `SGOver` drawMarkers ps


main = reactimatePioneerVS (VSMPEG "test.mpg") rotate
-- main = reactimatePioneerVS (VSStereoVidere "dont care") rotate

{-
main = do
    startServers
    pioneerResetOdometry
{-
    sleep 1
    (x, y, theta) <- pioneerSetVelTRGetPos (0.0) (pi/3)
    putStrLn ("x = " ++ show x ++ ", y = " ++ show y
              ++ ", theta = " ++ show theta)
    sleep 6
    (x, y, theta) <- pioneerSetVelTRGetPos (0.0) 0
    putStrLn ("x = " ++ show x ++ ", y = " ++ show y
              ++ ", theta = " ++ show theta)
    sleep 1
    (x, y, theta) <- pioneerSetVelTRGetPos (0.2) 0
    putStrLn ("x = " ++ show x ++ ", y = " ++ show y
              ++ ", theta = " ++ show theta)
    sleep 5
    (x, y, theta) <- pioneerSetVelTRGetPos (0.0) 0
    putStrLn ("x = " ++ show x ++ ", y = " ++ show y
              ++ ", theta = " ++ show theta)
-}
    sleep 1
    pioneerSetVelDiff (0.0) (-0.1)
    -- pioneerSetVelTR 0.0 (-pi/3)
    sleep 10
    (x, y, theta) <- pioneerStopGetPos
    putStrLn ("x = " ++ show x ++ ", y = " ++ show y
              ++ ", theta = " ++ show theta)
-}
